#!/usr/bin/ruby
# -*- coding: utf-8 -*-

#------ 顔認証資格確認結果用


require 'uri'
require 'net/http'

Net::HTTP.version_1_2

HOST = "localhost"
PORT = "8000"
USER = "ormaster"
PASSWD = "ormaster"
CONTENT_TYPE = "application/xml"


req = Net::HTTP::Post.new("/orca14/onlinequa4")

BODY = <<EOF
<data>
  <onlinequareq3 type ="record">
    <MessageHeader type ="record">
      <!-- 処理実行日時(YYYYMMDDHHmmss) ????? -->
      <ProcessExecutionTime type ="string">20220227143519</ProcessExecutionTime>
      <!-- 資格確認日 ???? -->
      <QualificationConfirmationDate type ="string"></QualificationConfirmationDate>
      <!-- 医療機関コード ????? -->
      <MedicalInstitutionCode type ="string">1311234567</MedicalInstitutionCode>
      <!-- 任意のファイル識別子(医療機関固有項目) -->
      <ArbitraryFileIdentifier type ="string"></ArbitraryFileIdentifier>
      <!-- 照会区分 -->
      <ReferenceClassification type ="string">9</ReferenceClassification>
      <!-- 処理結果区分 -->
      <SegmentOfResult type ="string">1</SegmentOfResult>
      <!-- エラーコード -->
      <ErrorCode type ="string"></ErrorCode>
      <!-- エラーメッセージ -->
      <ErrorMessage type ="string"></ErrorMessage>
      <!-- 文字コード識別 -->
      <CharacterCodeIdentifier type ="string">0</CharacterCodeIdentifier>
      <!-- メッセージボディ部 -->
    </MessageHeader>
      <MessageBody type ="record">
        <!-- 資格確認照会用情報 -->
        <QualificationConfirmSearchInfo type ="record">
          <!-- 保険者番号 -->
          <InsurerNumber type ="string">06140248</InsurerNumber>
          <!-- 被保険者証記号 -->
          <InsuredCardSymbol type ="string">1233</InsuredCardSymbol>
          <!-- 被保険者証番号 -->
          <InsuredIdentificationNumber type ="string">1244</InsuredIdentificationNumber>
          <!-- 被保険者証枝番 -->
          <InsuredBranchNumber type ="string">01</InsuredBranchNumber>
          <!-- 生年月日 -->
          <Birthdate type ="string">19900110</Birthdate>
          <!-- 限度額適用認定証提供同意フラグ -->
          <LimitApplicationCertificateRelatedConsFlg type ="string"></LimitApplicationCertificateRelatedConsFlg>
          <!-- 任意の識別子(医療機関固有項目) -->
          <ArbitraryIdentifier type ="string">00000000000,UIDUID</ArbitraryIdentifier>
        </QualificationConfirmSearchInfo>
        <!-- 処理結果状況 -->
        <ProcessingResultStatus type ="string">1</ProcessingResultStatus>
        <!-- 処理結果コード -->
        <ProcessingResultCode type ="string"></ProcessingResultCode>
        <!-- 処理結果メッセージ -->
        <ProcessingResultMessage type ="string"></ProcessingResultMessage>
        <!-- 資格有効性 ???? -->
        <QualificationValidity type ="string">1</QualificationValidity>
        <!-- 資格確認結果リスト -->
        <ResultList type ="record">
          <!-- 資格確認結果 -->
          <ResultOfQualificationConfirmation type ="array">
            <ResultOfQualificationConfirmation_child type ="record">
              <!-- 被保険者証区分 -->
              <InsuredCardClassification type ="string">01</InsuredCardClassification>
              <!-- 保険者番号 ???? -->
              <InsurerNumber type ="string">91919191;92987621</InsurerNumber>
              <!-- 被保険者証記号 ???? -->
              <InsuredCardSymbol type ="string"></InsuredCardSymbol>
              <!-- 被保険者証番号 ???? -->
              <InsuredIdentificationNumber type ="string">1234566</InsuredIdentificationNumber>
              <!-- 被保険者証枝番 ???? -->
              <InsuredBranchNumber type ="string"></InsuredBranchNumber>
              <!-- 本人・家族の別 ???? -->
              <PersonalFamilyClassification type ="string"></PersonalFamilyClassification>
              <!-- 被保険者氏名(世帯主氏名) ???? -->
              <InsuredName type ="string"></InsuredName>
              <!-- 氏名 ???? -->
              <Name type ="string"></Name>
              <!-- 氏名(その他) -->
              <NameOfOther type ="string"></NameOfOther>
              <!-- 氏名カナ ???? -->
              <NameKana type ="string"></NameKana>
              <!-- 氏名カナ(その他) -->
              <NameOfOtherKana type ="string"></NameOfOtherKana>
              <!-- 性別1 ???? -->
              <Sex1 type ="string"></Sex1>
              <!-- 性別2 -->
              <Sex2 type ="string"></Sex2>
              <!-- 生年月日 ???? -->
              <Birthdate type ="string">19950220</Birthdate>
              <!-- 住所 -->
              <Address type ="string">東京都港区新橋2-91-999</Address>
              <!-- 郵便番号 -->
              <PostNumber type ="string">105-0004</PostNumber>
              <!-- 被保険者証交付年月日 -->
              <InsuredCertificateIssuanceDate type ="string">20120401</InsuredCertificateIssuanceDate>
              <!-- 被保険者証有効開始年月日 -->
              <InsuredCardValidDate type ="string">入院 20200401;通院 20200401;</InsuredCardValidDate>
              <!-- 被保険者証有効終了年月日 -->
              <InsuredCardExpirationDate type ="string">入院 20250331;通院 20280420;</InsuredCardExpirationDate>
              <!-- 被保険者証一部負担金割合 -->
              <InsuredPartialContributionRatio type ="string">入院 000;通院 010;</InsuredPartialContributionRatio>
              <!-- 被保険者証一部負担限度額 -->
              <InsuredPartialContributionLimit type ="string">入院 500;通院 1000;</InsuredPartialContributionLimit>
              <!-- 未就学区分 -->
              <PreschoolClassification type ="string"></PreschoolClassification>
              <!-- 資格喪失事由 -->
              <ReasonOfLoss type ="string"></ReasonOfLoss>
              <!-- 保険者名称 -->
              <InsurerName type ="string"></InsurerName>
              <!-- 高齢受給者証情報 -->
              <ElderlyRecipientCertificateInfo type ="record">
                <!-- 高齢受給者証交付年月日 -->
                <ElderlyRecipientCertificateDate type ="string"></ElderlyRecipientCertificateDate>
                <!-- 高齢受給者証有効開始年月日 -->
                <ElderlyRecipientValidStartDate type ="string"></ElderlyRecipientValidStartDate>
                <!-- 高齢受給者証有効終了年月日 -->
                <ElderlyRecipientValidEndDate type ="string"></ElderlyRecipientValidEndDate>
                <!-- 高齢受給者証一部負担金割合 -->
                <ElderlyRecipientContributionRatio type ="string"></ElderlyRecipientContributionRatio>
              </ElderlyRecipientCertificateInfo>
              <!-- 限度額適用認定証提供同意フラグ -->
              <LimitApplicationCertificateRelatedConsFlg type ="string"></LimitApplicationCertificateRelatedConsFlg>
              <!-- 限度額適用認定証提供同意日時(YYYYMMDDHHmmss) -->
              <LimitApplicationCertificateRelatedConsTime type ="string"></LimitApplicationCertificateRelatedConsTime>
              <!-- 限度額適用認定証関連情報 -->
              <LimitApplicationCertificateRelatedInfo type ="record">
                <!-- 限度額適用認定証区分 -->
                <LimitApplicationCertificateClassification type ="string"></LimitApplicationCertificateClassification>
                <!-- 限度額適用認定証適用区分 -->
                <LimitApplicationCertificateClassificationFlag type ="string"></LimitApplicationCertificateClassificationFlag>
                <!-- 限度額適用認定証交付年月日 -->
                <LimitApplicationCertificateDate type ="string"></LimitApplicationCertificateDate>
                <!-- 限度額適用認定証有効開始年月日 -->
                <LimitApplicationCertificateValidStartDate type ="string"></LimitApplicationCertificateValidStartDate>
                <!-- 限度額適用認定証有効終了年月日 -->
                <LimitApplicationCertificateValidEndDate type ="string"></LimitApplicationCertificateValidEndDate>
                <!-- 限度額適用認定証長期入院該当年月日 -->
                <LimitApplicationCertificateLongTermDate type ="string"></LimitApplicationCertificateLongTermDate>
              </LimitApplicationCertificateRelatedInfo>
              <!-- 特定疾病療養受療証提供同意フラグ -->
              <SpecificDiseasesCertificateRelatedConsFlg type ="string"></SpecificDiseasesCertificateRelatedConsFlg>
              <!-- 特定疾病療養受療証提供同意日時(YYYYMMDDHHmmss) -->
              <SpecificDiseasesCertificateRelatedConsTime type ="string"></SpecificDiseasesCertificateRelatedConsTime>
              <!-- 特定疾病療養受療証情報リスト -->
              <SpecificDiseasesCertificateList type ="record">
                <!-- 特定疾病療養受療証情報 -->
                <SpecificDiseasesCertificateInfo type ="array">
                  <SpecificDiseasesCertificateInfo_child type ="record">
                    <!-- 特定疾病療養受療証認定疾病区分 -->
                    <SpecificDiseasesDiseaseCategory type ="string"></SpecificDiseasesDiseaseCategory>
                    <!-- 特定疾病療養受療証交付年月日 -->
                    <SpecificDiseasesCertificateDate type ="string"></SpecificDiseasesCertificateDate>
                    <!-- 特定疾病療養受療証有効開始年月日 -->
                    <SpecificDiseasesValidStartDate type ="string"></SpecificDiseasesValidStartDate>
                    <!-- 特定疾病療養受療証有効終了年月日 -->
                    <SpecificDiseasesValidEndDate type ="string"></SpecificDiseasesValidEndDate>
                    <!-- 特定疾病療養受療証自己負担限度額 -->
                    <SpecificDiseasesSelfPay type ="string"></SpecificDiseasesSelfPay>
                  </SpecificDiseasesCertificateInfo_child>
                </SpecificDiseasesCertificateInfo>
              </SpecificDiseasesCertificateList>
              <!-- 特定健診情報閲覧同意フラグ ???? -->
              <SpecificHealthCheckupsInfoConsFlg type ="string"></SpecificHealthCheckupsInfoConsFlg>
              <!-- 特定健診情報閲覧同意日時 -->
              <SpecificHealthCheckupsInfoConsTime type ="string"></SpecificHealthCheckupsInfoConsTime>
              <!-- 特定健診情報閲覧有効期限 -->
              <SpecificHealthCheckupsInfoAvailableTime type ="string"></SpecificHealthCheckupsInfoAvailableTime>
              <!-- 薬剤情報閲覧同意フラグ ???? -->
              <PharmacistsInfoConsFlg type ="string"></PharmacistsInfoConsFlg>
              <!-- 薬剤情報閲覧同意日時 -->
              <PharmacistsInfoConsTime type ="string"></PharmacistsInfoConsTime>
              <!-- 薬剤情報閲覧有効期限 -->
              <PharmacistsInfoAvailableTime type ="string"></PharmacistsInfoAvailableTime>
              <!-- 任意の識別子(医療機関固有項目) -->
              <ArbitraryIdentifier type ="string"></ArbitraryIdentifier>
              <!-- 照会番号 ???? -->
              <ReferenceNumber type ="string"></ReferenceNumber>
            </ResultOfQualificationConfirmation_child>
            <ResultOfQualificationConfirmation_child type ="record">
              <!-- 被保険者証区分 -->
              <InsuredCardClassification type ="string">01</InsuredCardClassification>
              <!-- 保険者番号 ???? -->
              <InsurerNumber type ="string">91919191;92987621</InsurerNumber>
              <!-- 被保険者証記号 ???? -->
              <InsuredCardSymbol type ="string"></InsuredCardSymbol>
              <!-- 被保険者証番号 ???? -->
              <InsuredIdentificationNumber type ="string">2134566</InsuredIdentificationNumber>
              <!-- 被保険者証枝番 ???? -->
              <InsuredBranchNumber type ="string"></InsuredBranchNumber>
              <!-- 本人・家族の別 ???? -->
              <PersonalFamilyClassification type ="string"></PersonalFamilyClassification>
              <!-- 被保険者氏名(世帯主氏名) ???? -->
              <InsuredName type ="string"></InsuredName>
              <!-- 氏名 ???? -->
              <Name type ="string"></Name>
              <!-- 氏名(その他) -->
              <NameOfOther type ="string"></NameOfOther>
              <!-- 氏名カナ ???? -->
              <NameKana type ="string"></NameKana>
              <!-- 氏名カナ(その他) -->
              <NameOfOtherKana type ="string"></NameOfOtherKana>
              <!-- 性別1 ???? -->
              <Sex1 type ="string"></Sex1>
              <!-- 性別2 -->
              <Sex2 type ="string"></Sex2>
              <!-- 生年月日 ???? -->
              <Birthdate type ="string">20150304</Birthdate>
              <!-- 住所 -->
              <Address type ="string"></Address>
              <!-- 郵便番号 -->
              <PostNumber type ="string"></PostNumber>
              <!-- 被保険者証交付年月日 -->
              <InsuredCertificateIssuanceDate type ="string">20120401</InsuredCertificateIssuanceDate>
              <!-- 被保険者証有効開始年月日 -->
              <InsuredCardValidDate type ="string">入院 20200401;通院 20200401;</InsuredCardValidDate>
              <!-- 被保険者証有効終了年月日 -->
              <InsuredCardExpirationDate type ="string">入院 20250331;通院 20280331;</InsuredCardExpirationDate>
              <!-- 被保険者証一部負担金割合 -->
              <InsuredPartialContributionRatio type ="string">入院 000;通院 010;</InsuredPartialContributionRatio>
              <!-- 未就学区分 -->
              <PreschoolClassification type ="string"></PreschoolClassification>
              <!-- 資格喪失事由 -->
              <ReasonOfLoss type ="string"></ReasonOfLoss>
              <!-- 保険者名称 -->
              <InsurerName type ="string"></InsurerName>
              <!-- 高齢受給者証情報 -->
              <ElderlyRecipientCertificateInfo type ="record">
                <!-- 高齢受給者証交付年月日 -->
                <ElderlyRecipientCertificateDate type ="string"></ElderlyRecipientCertificateDate>
                <!-- 高齢受給者証有効開始年月日 -->
                <ElderlyRecipientValidStartDate type ="string"></ElderlyRecipientValidStartDate>
                <!-- 高齢受給者証有効終了年月日 -->
                <ElderlyRecipientValidEndDate type ="string"></ElderlyRecipientValidEndDate>
                <!-- 高齢受給者証一部負担金割合 -->
                <ElderlyRecipientContributionRatio type ="string"></ElderlyRecipientContributionRatio>
              </ElderlyRecipientCertificateInfo>
              <!-- 限度額適用認定証提供同意フラグ -->
              <LimitApplicationCertificateRelatedConsFlg type ="string"></LimitApplicationCertificateRelatedConsFlg>
              <!-- 限度額適用認定証提供同意日時(YYYYMMDDHHmmss) -->
              <LimitApplicationCertificateRelatedConsTime type ="string"></LimitApplicationCertificateRelatedConsTime>
              <!-- 限度額適用認定証関連情報 -->
              <LimitApplicationCertificateRelatedInfo type ="record">
                <!-- 限度額適用認定証区分 -->
                <LimitApplicationCertificateClassification type ="string"></LimitApplicationCertificateClassification>
                <!-- 限度額適用認定証適用区分 -->
                <LimitApplicationCertificateClassificationFlag type ="string"></LimitApplicationCertificateClassificationFlag>
                <!-- 限度額適用認定証交付年月日 -->
                <LimitApplicationCertificateDate type ="string"></LimitApplicationCertificateDate>
                <!-- 限度額適用認定証有効開始年月日 -->
                <LimitApplicationCertificateValidStartDate type ="string"></LimitApplicationCertificateValidStartDate>
                <!-- 限度額適用認定証有効終了年月日 -->
                <LimitApplicationCertificateValidEndDate type ="string"></LimitApplicationCertificateValidEndDate>
                <!-- 限度額適用認定証長期入院該当年月日 -->
                <LimitApplicationCertificateLongTermDate type ="string"></LimitApplicationCertificateLongTermDate>
              </LimitApplicationCertificateRelatedInfo>
              <!-- 特定疾病療養受療証提供同意フラグ -->
              <SpecificDiseasesCertificateRelatedConsFlg type ="string"></SpecificDiseasesCertificateRelatedConsFlg>
              <!-- 特定疾病療養受療証提供同意日時(YYYYMMDDHHmmss) -->
              <SpecificDiseasesCertificateRelatedConsTime type ="string"></SpecificDiseasesCertificateRelatedConsTime>
              <!-- 特定疾病療養受療証情報リスト -->
              <SpecificDiseasesCertificateList type ="record">
                <!-- 特定疾病療養受療証情報 -->
                <SpecificDiseasesCertificateInfo type ="array">
                  <SpecificDiseasesCertificateInfo_child type ="record">
                    <!-- 特定疾病療養受療証認定疾病区分 -->
                    <SpecificDiseasesDiseaseCategory type ="string"></SpecificDiseasesDiseaseCategory>
                    <!-- 特定疾病療養受療証交付年月日 -->
                    <SpecificDiseasesCertificateDate type ="string"></SpecificDiseasesCertificateDate>
                    <!-- 特定疾病療養受療証有効開始年月日 -->
                    <SpecificDiseasesValidStartDate type ="string"></SpecificDiseasesValidStartDate>
                    <!-- 特定疾病療養受療証有効終了年月日 -->
                    <SpecificDiseasesValidEndDate type ="string"></SpecificDiseasesValidEndDate>
                    <!-- 特定疾病療養受療証自己負担限度額 -->
                    <SpecificDiseasesSelfPay type ="string"></SpecificDiseasesSelfPay>
                  </SpecificDiseasesCertificateInfo_child>
                </SpecificDiseasesCertificateInfo>
              </SpecificDiseasesCertificateList>
              <!-- 特定健診情報閲覧同意フラグ ???? -->
              <SpecificHealthCheckupsInfoConsFlg type ="string"></SpecificHealthCheckupsInfoConsFlg>
              <!-- 特定健診情報閲覧同意日時 -->
              <SpecificHealthCheckupsInfoConsTime type ="string"></SpecificHealthCheckupsInfoConsTime>
              <!-- 特定健診情報閲覧有効期限 -->
              <SpecificHealthCheckupsInfoAvailableTime type ="string"></SpecificHealthCheckupsInfoAvailableTime>
              <!-- 薬剤情報閲覧同意フラグ ???? -->
              <PharmacistsInfoConsFlg type ="string"></PharmacistsInfoConsFlg>
              <!-- 薬剤情報閲覧同意日時 -->
              <PharmacistsInfoConsTime type ="string"></PharmacistsInfoConsTime>
              <!-- 薬剤情報閲覧有効期限 -->
              <PharmacistsInfoAvailableTime type ="string"></PharmacistsInfoAvailableTime>
              <!-- 任意の識別子(医療機関固有項目) -->
              <ArbitraryIdentifier type ="string"></ArbitraryIdentifier>
              <!-- 照会番号 ???? -->
              <ReferenceNumber type ="string"></ReferenceNumber>
            </ResultOfQualificationConfirmation_child>
          </ResultOfQualificationConfirmation>
        </ResultList>
      </MessageBody>
  </onlinequareq3>
</data>
EOF

req.content_length = BODY.size
req.content_type = CONTENT_TYPE
req.body = BODY
req.basic_auth(USER, PASSWD)
#  puts req.body

Net::HTTP.start(HOST, PORT) {|http|
  res = http.request(req)
  puts res.body
#--------------------------------------
#foo = File.open("foo.xml",'w')
#foo.puts res.body
#foo.close
#system("firefox", "foo.xml")
#----------------------------------
}

